#!/usr/bin/perl
#--NetShopOwner-CGI-version:5.0.0.0--

;#
;# s_shop_index.cgi
;# [X}[gtH]gbvy[W
;# (C) 2012 ЃWXgVXe
;#
;# last modified YYYY/MM/DD
;#

use strict;
use uselib;
use defnsopath_shops;
use NsoVersionSP 1.00;
use Lib::SiteStatus;
use NsoUserAgent;
use NsoMobileAffiliate;
use DB::NsoShopCampaignDB;
use DB::NsoArticleCampaignDB;

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();
my $NsoMisc       = NsoMisc->new();
my $NsoUserAgent  = NsoUserAgent->new();

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $status_err;

my $NsoShopCampaignDB = NsoShopCampaignDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
my $NsoArticleCampaignDB = NsoArticleCampaignDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
	);
	
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing();
	$SiteStatus->CheckUserAgentSmartPhone();
}

;#
;# C
;#
sub main {

	# ev[gu
	my $html_templ_dir  = "./";
	my $html_templ_kind = "nsoDB/templ/";
	my $DataHead = "s_shop_index_head.htmp";
	my $DataFoot = "s_shop_index_foot.htmp";
	my %TextHead = ();
	my %TextFoot = ();
	my %htmls    = ();

	# ev[gǍ
	my $NsoTemplHead = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataHead });
	my $NsoTemplFoot = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataFoot });

	# Ly[Xg쐬
	my $body_contents;
	if($ConfigSystem{navigationCampaign_view}{smartphone}{flag} eq "1"){
		&makeCampaignList( {
			htmls         => \%htmls         ,
			BodyContents  => \$body_contents ,
		} );
	}

	# ev[gu
	my %replace_templ_head = (
		Text  => \%TextHead ,
		htmls => \%htmls    ,
	);
	my %replace_templ_foot = (
		Text => \%TextFoot ,
	);

	# \HTML쐬
	my $contents = "";
	$contents .= $NsoTemplHead->replace_templ(\%replace_templ_head);
	$contents .= $body_contents;
	$contents .= $NsoTemplFoot->replace_templ(\%replace_templ_foot);

	print $NsoMisc->print_header();
	print $contents;

	exit();
}

;#
;# Ly[ꗗ쐬
;# @param %htmls         upnbVAG[bZ[W
;#         BodyContents  {fBHTMLA[vʐꂽ
;# @return Ȃ
;#
sub makeCampaignList(){
	my ($params) = shift if @_;

	my $htmls         = $params->{htmls};
	my $body_contents = $params->{BodyContents};

	# ev[g
	my $html_templ_dir  = "./";
	my $html_templ_kind = "nsoDB/templ/";
	my $DataBody1 = "s_shop_index_body1.htmp";
	my $DataBody2 = "s_shop_index_body2.htmp";
	my $DataBody3 = "s_shop_index_body3.htmp";
	my $DataBody4 = "s_shop_index_body4.htmp";

	# ev[gǍ
	my $NsoTemplBody1 = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataBody1 });
	my $NsoTemplBody2 = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataBody2 });
	my $NsoTemplBody3 = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataBody3 });
	my $NsoTemplBody4 = NsoTempl->new({ DataDir=>$html_templ_dir, DirKind=>$html_templ_kind, Data=>$DataBody4 });

	# VbvLy[ǂݍ
	my $shop_contents = "";
	if($ConfigSystem{navigationCampaign_view}{smartphone}{flag_shop} eq "1"){
		my %resultShopCampaign = $NsoShopCampaignDB->GetShopCampaignForNavigation();
		my %resultShopCampaignHash = (
			RecordList  => $resultShopCampaign{RecordList},
			RecordCount => $resultShopCampaign{RecordCount},
			status_err  => $resultShopCampaign{status_err},
		);
		# DBG[
		if ($resultShopCampaignHash{status_err} ne ""){
			$htmls->{status_err} = 'DB擾Ɏs܂B(1)<br>' . $resultShopCampaignHash{status_err};
			return;
		} elsif ($resultShopCampaignHash{RecordCount} == 0){
			# R[hȂꍇA$shop_contents͋̂܂
		} else {
			my %shopCampaign = %{$resultShopCampaignHash{RecordList}[0]};

			my %TextBody2 = ();
			# isGXP[vāA<br>^Oɕϊj
			$TextBody2{ShopCampaignExplanation} = $NsoMisc->newline_br($NsoMisc->unesc_newline($shopCampaign{ExplanationSmartPhone}));

			my %replace_templ_body2 = (Text => \%TextBody2 ,);
			$shop_contents .= $NsoTemplBody2->replace_templ(\%replace_templ_body2);
		}
	}

	# iLy[ǂݍ
	my $article_contents = "";
	if($ConfigSystem{navigationCampaign_view}{smartphone}{flag_article} eq "1"){
		my %resultArticleCampaign = $NsoArticleCampaignDB->GetArticleCampaignForNavigation();
		my %resultArticleCampaignHash = (
			RecordList  => $resultArticleCampaign{RecordList},
			RecordCount => $resultArticleCampaign{RecordCount},
			status_err  => $resultArticleCampaign{status_err},
		);
		# DBG[
		if ($resultArticleCampaignHash{status_err} ne ""){
			$htmls->{status_err} = 'DB擾Ɏs܂B(2)<br>' .  $resultArticleCampaignHash{status_err};
			return;
		} elsif ($resultArticleCampaignHash{RecordCount} == 0){
			# R[hȂꍇA$article_contents͋̂܂
		} else {
			my @articleCampaignArray = @{$resultArticleCampaignHash{RecordList}};

			for(my $i = 0 ; $i < @articleCampaignArray ; $i++ ){
				my %TextBody3 = ();
				$TextBody3{ArticleCampaignID}   = $articleCampaignArray[$i]{CampaignID};
				$TextBody3{ArticleCampaignName} = $articleCampaignArray[$i]{CampaignName};

				my %replace_templ_body3 = (Text => \%TextBody3 ,);
				$article_contents .= $NsoTemplBody3->replace_templ(\%replace_templ_body3)
			}
		}
	}

	# \VbvoriLy[1ł΁ALy[wb_tb^ĕ\HTML쐬
	if($shop_contents ne "" || $article_contents ne ""){
		my %TextBody1 = ();
		my %replace_templ_body1 = (Text => \%TextBody1 ,);
		my %TextBody4 = ();
		my %replace_templ_body4 = (Text => \%TextBody4 ,);
		$$body_contents = "";
		$$body_contents .= $NsoTemplBody1->replace_templ(\%replace_templ_body1);
		$$body_contents .= $shop_contents;
		$$body_contents .= $article_contents;
		$$body_contents .= $NsoTemplBody4->replace_templ(\%replace_templ_body4);
	} else{
		$$body_contents = "";
	}
}


















